--[[


Test...	

]]

-- Constants

color = {red = 1, green = .5, blue = .25}

SPACE_BUFFER = "";


-- Variables
local DopieArenaInfo_VarsLoaded = 0;
local DopieArenaInfo_bTurnedOn = true;
local DopieArenaInfo_bCTRLDown = false;
local DopieArenaInfo_PassOverData = {};
local DopieArenaInfo_ChangeColorID = "";
local DopieArenaInfo_ChangeCheckboxID = "";
local DopieArenaInfo_ChangeTextureID = "";
local DopieArenaInfo_CurrentFrameNumber = 1;
local DopieArenaInfo_bFrameAddCalled = false;


-- DB Connections
PUG_ARENA = {}
PUG_ARENA_CONFIG = {}

----------------------------------------------------------------------------------
-- 
-- Window Event Handlers
-- 
---------------------------------------------------------------------------------

function DopieArenaInfo_OnEvent(event)
   if ( (event == "VARIABLES_LOADED") and (DopieArenaInfo_VarsLoaded == 0) ) then
      DopieArenaInfo_InitializeVars();
      DopieArenaInfo_VarsLoaded = 1;
      
      
   
   elseif(event == "UPDATE_MOUSEOVER_UNIT") then
   	
   	--if not UnitIsFriend("player","mouseover") then
		local class = UnitClass("mouseover");
   	 	if (UnitCreatureType("mouseover")== "Humanoid" or class=="Druid" or class=="Shaman") and not strfind(UnitName("mouseover"), " ") then
   	 		local sName;
   	 		local arrName = { strsplit("-",GetUnitName("mouseover",true)); };
   	 		local lArrayCount = table.getn(arrName);
   	 		if (lArrayCount == 2) then
   	 			sName = trim(arrName[2]) .. "-" .. trim(arrName[1]);
   	 		end
   	 		if (lArrayCount == 1) then
   	 			sName = GetRealmName() .. "-" .. trim(arrName[1]);
   	 		end
   	 		DopieArenaInfo_CheckMouseOver(string.lower(sName));
   	 	end
   	--end
   elseif(event == "MODIFIER_STATE_CHANGED") then
   	if (arg1 == "CTRL") then
   		if (arg2 == 1) then
   			DopieArenaInfo_bCTRLDown = true;
   		end
   		if (arg2 == 0) then
   			DopieArenaInfo_bCTRLDown = false;
   		end
   	end
   
   
   elseif(event == "PLAYER_TARGET_CHANGED") then
   	if DopieArenaInfo_bCTRLDown then
   		-- Code I stole to detect if its a human target
		local class = UnitClass("target");
   	 	if (UnitCreatureType("target")== "Humanoid" or class=="Druid" or class=="Shaman") and not strfind(UnitName("target"), " ") then
   	 		local sName;
   	 		local arrName = { strsplit("-",GetUnitName("target",true)); };
   	 		local lArrayCount = table.getn(arrName);
   	 		if (lArrayCount == 2) then
   	 			sName = trim(arrName[2]) .. "-" .. trim(arrName[1]);
   	 		end
   	 		if (lArrayCount == 1) then
   	 			sName = GetRealmName() .. "-" .. trim(arrName[1]);
   	 		end
   	 		DopieArenaInfo_AddNewDisplayFrame();
   	 		DopieArenaInfo_DisplayCharacterData(string.lower(sName),true);
   	 	end
   	end	
   elseif(event == "ZONE_CHANGED_NEW_AREA") then
      	
   end
end

function trim (s)
      return (string.gsub(s, "^%s*(.-)%s*$", "%1"))
   end

function DopieArenaInfo_OnLoad()
--	Print_Msg("Dopie's ARENA INFO Mod Beta 1.0 Loading....");
	DopieArenaInfo_Register();
	Print_Msg("Dopie's ARENA INFO Mod Beta 1.0 Loaded....");
end


function DopieArenaInfo_IsPvpZone(sZone)

	if(sZone == "Warsong Gulch") then
		return(true);
	elseif(sZone == "Arathi Basin") then
		return(true);
	elseif(sZone == "Alterac Valley") then
		return(true);
	elseif(sZone == "Eye of the Storm") then
		return(true);
	end
	return(false);
end


----------------------------------------------------------------------------------
-- 
-- Window Event Support Functions (hooks kinda...)
-- 
---------------------------------------------------------------------------------

function DopieArenaInfo_Register()
	
	-- Register Event Hooks
	this:RegisterEvent("VARIABLES_LOADED");
	this:RegisterEvent("ZONE_CHANGED_NEW_AREA");
	this:RegisterEvent("UPDATE_MOUSEOVER_UNIT");
	this:RegisterEvent("PLAYER_TARGET_CHANGED");
	this:RegisterEvent("MODIFIER_STATE_CHANGED");
	
	
	
	-- Register Slash commands
	
	SLASH_PTAWHO1 = "/ptawho";
	SlashCmdList["PTAWHO"] = DopieArenaInfo_PrintCharacterData;
	
	SLASH_PTAON1 = "/PTAon";
	SlashCmdList["PTAON"] = DopieArenaInfo_Enable;

	SLASH_PTAOFF1 = "/PTAoff";
	SlashCmdList["PTAOFF"] = DopieArenaInfo_Disable;

	
end

function DopieArenaInfo_InitializeVars()

	if (PUG_ARENA["ARENA_CHARACTERS"] == nil) then
	 PUG_ARENA["ARENA_CHARACTERS"] = {};	
	end 
	
	if (PUG_ARENA_CONFIG["ARENA_CONFIG"] == nil) then
		Print_Msg("Setting Config defaults");
		 PUG_ARENA_CONFIG["ARENA_CONFIG"] = {
		 	["talents"] = {
				["enabled"] = 1,
				["color"] = "|cffffffff",
			},
			["mhspeed"] = {
				["enabled"] = 1,
				["color"] = "|cffffffff",
			},
			["ohdps"] = {
				["enabled"] = 1,
				["color"] = "|cffffffff",
			},
			["hp"] = {
				["enabled"] = 1,
				["color"] = "|cffffffff",
			},
			["rncrit"] = {
				["enabled"] = 1,
				["color"] = "|cffffffff",
			},
			["rnspeed"] = {
				["enabled"] = 1,
				["color"] = "|cffffffff",
			},
			["mp"] = {
				["enabled"] = 1,
				["color"] = "|cffffffff",
			},
			["mhdmg"] = {
				["enabled"] = 1,
				["color"] = "|cffffffff",
			},
			["rndps"] = {
				["enabled"] = 1,
				["color"] = "|cffffffff",
			},
			["ohspeed"] = {
				["enabled"] = 1,
				["color"] = "|cffffffff",
			},
			["rndmg"] = {
				["enabled"] = 1,
				["color"] = "|cffffffff",
			},
			["5v5r"] = {
				["enabled"] = 1,
				["color"] = "|cffffffff",
			},
			["rnatkpwr"] = {
				["enabled"] = 1,
				["color"] = "|cffffffff",
			},
			["bheal"] = {
				["color"] = "|cffffffff",
				["enabled"] = 1,
			},
			["rnhitr"] = {
				["enabled"] = 1,
				["color"] = "|cffffffff",
			},
			["2v2r"] = {
				["enabled"] = 1,
				["color"] = "|cffffffff",
			},
			["sdmg"] = {
				["enabled"] = 1,
				["color"] = "|cffffffff",
			},
			["default"] = {
				["enabled"] = 1,
				["color"] = "|cffffffff",
			},
			["classrace"] = {
				["enabled"] = 1,
				["color"] = "|cffffffff",
			},
			["resil"] = {
				["enabled"] = 1,
				["color"] = "|cffffffff",
			},
			["mhdps"] = {
				["enabled"] = 1,
				["color"] = "|cffffffff",
			},
			["mhatkpwr"] = {
				["enabled"] = 1,
				["color"] = "|cffffffff",
			},
			["mhhitr"] = {
				["enabled"] = 1,
				["color"] = "|cffffffff",
			},
			["ohdmg"] = {
				["enabled"] = 1,
				["color"] = "|cffffffff",
			},
			["3v3r"] = {
				["enabled"] = 1,
				["color"] = "|cffffffff",
			},
			["mhcrit"] = {
				["enabled"] = 1,
				["color"] = "|cffffffff",
		},
		 };	
	end 
	
end

----------------------------------------------------------------------------------
-- 
-- Private Functions
-- 
---------------------------------------------------------------------------------

function DopieArenaInfo_GetNextFrameNumber()

	for i=1, 5 do
		local oFrame = getglobal("DopieArenaInfoFrame" .. i);
		if(oFrame:IsVisible()) then
	
		else
			return i;
		end
	end
	
	return 5;
end

function DopieArenaInfo_AddNewDisplayFrame()
	local iNum = DopieArenaInfo_GetNextFrameNumber();
	DopieArenaInfo_CurrentFrameNumber = iNum;
	local frame = getglobal("DopieArenaInfoFrame" .. iNum);
	frame:Show();
end

function DopieArenaInfo_ToggleConfig()
	local frame = getglobal("DopieArenaInfoConfig");
	if (frame) then
		if(  frame:IsVisible() ) then
			frame:Hide();
		else
			DopieArenaInfo_LoadConfigColors();
			frame:Show();
		end
	end

end

function DopieArenaInfo_CheckMouseOver(who)

	DopieArenaInfo_DisplayCharacterData(who,false);
end


function DopieArenaInfo_ChangeCheckboxID(a_sID)
	DopieArenaInfo_ChangeCheckboxID = a_sID;
end


function DopieArenaInfo_ChangeColor(a_sID, a_sTextID)
	DopieArenaInfo_ChangeColorID = a_sID;
	DopieArenaInfo_ChangeTextureID = a_sTextID;
end



function DopieArenaInfo_ChangeColorExample()
	local r,g,b = ColorPickerFrame:GetColorRGB();
	local sID = DopieArenaInfo_ChangeColorID;
	local oConfig = PUG_ARENA_CONFIG["ARENA_CONFIG"][sID];
	
	local oTexture = getglobal(DopieArenaInfo_ChangeTextureID);
	
	oTexture:SetTexture(r, g, b);
	oConfig.color = "|cff" .. DopieArenaInfo_RGBPercToHex(r,g,b);
	
	PUG_ARENA_CONFIG["ARENA_CONFIG"][sID] = oConfig;				
	
end


function DopieArenaInfo_ConfigChecked(a_sConfigDBKey,a_sConfigCheckbox)
	
	local oChkBox = getglobal(a_sConfigCheckbox);
	
	if(oChkBox ~= nil) then
		local oConfig = PUG_ARENA_CONFIG["ARENA_CONFIG"][a_sConfigDBKey];	
		if(oConfig == nil) then
			oConfig = {};
		end
		if(oChkBox:GetChecked()) then
			oConfig.enabled = 1;
		else
			oConfig.enabled = 0;
		end
		PUG_ARENA_CONFIG["ARENA_CONFIG"][a_sConfigDBKey] = oConfig;
	end
	
end

function DopieArenaInfo_LoadConfigColors()
	local r, g, b;
	local oConfig;
	
	oConfig = PUG_ARENA_CONFIG["ARENA_CONFIG"]["default"];	
	if(oConfig ~= nil) then
		r,g,b = DopieArenaInfo_HexToRGBPerc(oConfig.color);
		DopieArenaInfoConfig_ColorAreaDefault:SetTexture(r, g, b);
	end
	
	oConfig = PUG_ARENA_CONFIG["ARENA_CONFIG"]["hp"];	
	if(oConfig ~= nil) then
		r,g,b = DopieArenaInfo_HexToRGBPerc(oConfig.color);
		DopieArenaInfoConfig_ColorAreaHP:SetTexture(r, g, b);
		DopieArenaInfoConfig_chkHP:SetChecked(oConfig.enabled);
	end
	
	oConfig = PUG_ARENA_CONFIG["ARENA_CONFIG"]["mp"];	
	if(oConfig ~= nil) then
		r,g,b = DopieArenaInfo_HexToRGBPerc(oConfig.color);
		DopieArenaInfoConfig_ColorAreaMP:SetTexture(r, g, b);
		DopieArenaInfoConfig_chkMP:SetChecked(oConfig.enabled);
	end
	
	oConfig = PUG_ARENA_CONFIG["ARENA_CONFIG"]["talents"];	
	if(oConfig ~= nil) then
		r,g,b = DopieArenaInfo_HexToRGBPerc(oConfig.color);
		DopieArenaInfoConfig_ColorAreaTalents:SetTexture(r, g, b);
		DopieArenaInfoConfig_chkTalents:SetChecked(oConfig.enabled);
	end
	
	oConfig = PUG_ARENA_CONFIG["ARENA_CONFIG"]["classrace"];	
	if(oConfig ~= nil) then
		r,g,b = DopieArenaInfo_HexToRGBPerc(oConfig.color);
		DopieArenaInfoConfig_ColorAreaClassRace:SetTexture(r, g, b);
		DopieArenaInfoConfig_chkClassRace:SetChecked(oConfig.enabled);
	end
	
	oConfig = PUG_ARENA_CONFIG["ARENA_CONFIG"]["bheal"];	
	if(oConfig ~= nil) then
		r,g,b = DopieArenaInfo_HexToRGBPerc(oConfig.color);
		DopieArenaInfoConfig_ColorAreaBHeal:SetTexture(r, g, b);
		DopieArenaInfoConfig_chkBHeal:SetChecked(oConfig.enabled);
	end
	
	oConfig = PUG_ARENA_CONFIG["ARENA_CONFIG"]["sdmg"];	
	if(oConfig ~= nil) then
		r,g,b = DopieArenaInfo_HexToRGBPerc(oConfig.color);
		DopieArenaInfoConfig_ColorAreaSDmg:SetTexture(r, g, b);
		DopieArenaInfoConfig_chkSDmg:SetChecked(oConfig.enabled);
	end
	
	oConfig = PUG_ARENA_CONFIG["ARENA_CONFIG"]["mhdmg"];	
	if(oConfig ~= nil) then
		r,g,b = DopieArenaInfo_HexToRGBPerc(oConfig.color);
		DopieArenaInfoConfig_ColorAreaMhDmg:SetTexture(r, g, b);
		DopieArenaInfoConfig_chkMhDmg:SetChecked(oConfig.enabled);
	end
	
	oConfig = PUG_ARENA_CONFIG["ARENA_CONFIG"]["mhdps"];	
	if(oConfig ~= nil) then
		r,g,b = DopieArenaInfo_HexToRGBPerc(oConfig.color);
		DopieArenaInfoConfig_ColorAreaMhDps:SetTexture(r, g, b);
		DopieArenaInfoConfig_chkMhDps:SetChecked(oConfig.enabled);
	end	
	
	oConfig = PUG_ARENA_CONFIG["ARENA_CONFIG"]["mhspeed"];	
	if(oConfig ~= nil) then
		r,g,b = DopieArenaInfo_HexToRGBPerc(oConfig.color);
		DopieArenaInfoConfig_ColorAreaMhSpeed:SetTexture(r, g, b);
		DopieArenaInfoConfig_chkMhSpeed:SetChecked(oConfig.enabled);
	end
	
	
	oConfig = PUG_ARENA_CONFIG["ARENA_CONFIG"]["ohdmg"];	
	if(oConfig ~= nil) then
		r,g,b = DopieArenaInfo_HexToRGBPerc(oConfig.color);
		DopieArenaInfoConfig_ColorAreaOhDmg:SetTexture(r, g, b);
		DopieArenaInfoConfig_chkOhDmg:SetChecked(oConfig.enabled);
	end
		
	oConfig = PUG_ARENA_CONFIG["ARENA_CONFIG"]["ohdps"];	
	if(oConfig ~= nil) then
		r,g,b = DopieArenaInfo_HexToRGBPerc(oConfig.color);
		DopieArenaInfoConfig_ColorAreaOhDps:SetTexture(r, g, b);
		DopieArenaInfoConfig_chkOhDps:SetChecked(oConfig.enabled);
	end	

	oConfig = PUG_ARENA_CONFIG["ARENA_CONFIG"]["ohspeed"];	
	if(oConfig ~= nil) then
		r,g,b = DopieArenaInfo_HexToRGBPerc(oConfig.color);
		DopieArenaInfoConfig_ColorAreaOhSpeed:SetTexture(r, g, b);
		DopieArenaInfoConfig_chkOhSpeed:SetChecked(oConfig.enabled);
	end
	
	oConfig = PUG_ARENA_CONFIG["ARENA_CONFIG"]["rndmg"];	
	if(oConfig ~= nil) then
		r,g,b = DopieArenaInfo_HexToRGBPerc(oConfig.color);
		DopieArenaInfoConfig_ColorAreaRnDmg:SetTexture(r, g, b);
		DopieArenaInfoConfig_chkRnDmg:SetChecked(oConfig.enabled);
	end
	
	oConfig = PUG_ARENA_CONFIG["ARENA_CONFIG"]["rndps"];	
	if(oConfig ~= nil) then
		r,g,b = DopieArenaInfo_HexToRGBPerc(oConfig.color);
		DopieArenaInfoConfig_ColorAreaRnDps:SetTexture(r, g, b);
		DopieArenaInfoConfig_chkRnDps:SetChecked(oConfig.enabled);
	end	
	
	oConfig = PUG_ARENA_CONFIG["ARENA_CONFIG"]["rnspeed"];	
	if(oConfig ~= nil) then
		r,g,b = DopieArenaInfo_HexToRGBPerc(oConfig.color);
		DopieArenaInfoConfig_ColorAreaRnSpeed:SetTexture(r, g, b);
		DopieArenaInfoConfig_chkRnSpeed:SetChecked(oConfig.enabled);
	end
	
	oConfig = PUG_ARENA_CONFIG["ARENA_CONFIG"]["rnatkpwr"];	
	if(oConfig ~= nil) then
		r,g,b = DopieArenaInfo_HexToRGBPerc(oConfig.color);
		DopieArenaInfoConfig_ColorAreaRnAtkPwr:SetTexture(r, g, b);
		DopieArenaInfoConfig_chkRnAtkPwr:SetChecked(oConfig.enabled);
	end
	
	oConfig = PUG_ARENA_CONFIG["ARENA_CONFIG"]["rnhitr"];	
	if(oConfig ~= nil) then
		r,g,b = DopieArenaInfo_HexToRGBPerc(oConfig.color);
		DopieArenaInfoConfig_ColorAreaRnHitr:SetTexture(r, g, b);
		DopieArenaInfoConfig_chkRnHitr:SetChecked(oConfig.enabled);
	end
	
	oConfig = PUG_ARENA_CONFIG["ARENA_CONFIG"]["rncrit"];	
	if(oConfig ~= nil) then
		r,g,b = DopieArenaInfo_HexToRGBPerc(oConfig.color);
		DopieArenaInfoConfig_ColorAreaRnCrit:SetTexture(r, g, b);
		DopieArenaInfoConfig_chkRnCrit:SetChecked(oConfig.enabled);
	end
	
	
	oConfig = PUG_ARENA_CONFIG["ARENA_CONFIG"]["mhatkpwr"];	
	if(oConfig ~= nil) then
		r,g,b = DopieArenaInfo_HexToRGBPerc(oConfig.color);
		DopieArenaInfoConfig_ColorAreaMhAtkPwr:SetTexture(r, g, b);
		DopieArenaInfoConfig_chkMhAtkPwr:SetChecked(oConfig.enabled);
	end

	oConfig = PUG_ARENA_CONFIG["ARENA_CONFIG"]["mhhitr"];	
	if(oConfig ~= nil) then
		r,g,b = DopieArenaInfo_HexToRGBPerc(oConfig.color);
		DopieArenaInfoConfig_ColorAreaMhHitr:SetTexture(r, g, b);
		DopieArenaInfoConfig_chkMhHitr:SetChecked(oConfig.enabled);
	end

	oConfig = PUG_ARENA_CONFIG["ARENA_CONFIG"]["mhcrit"];	
	if(oConfig ~= nil) then
		r,g,b = DopieArenaInfo_HexToRGBPerc(oConfig.color);
		DopieArenaInfoConfig_ColorAreaMhCrit:SetTexture(r, g, b);
		DopieArenaInfoConfig_chkMhCrit:SetChecked(oConfig.enabled);
	end
	
	oConfig = PUG_ARENA_CONFIG["ARENA_CONFIG"]["resil"];	
	if(oConfig ~= nil) then
		r,g,b = DopieArenaInfo_HexToRGBPerc(oConfig.color);
		DopieArenaInfoConfig_ColorAreaResil:SetTexture(r, g, b);
		DopieArenaInfoConfig_chkResil:SetChecked(oConfig.enabled);
	end
	
	oConfig = PUG_ARENA_CONFIG["ARENA_CONFIG"]["2v2r"];	
	if(oConfig ~= nil) then
		r,g,b = DopieArenaInfo_HexToRGBPerc(oConfig.color);
		DopieArenaInfoConfig_ColorArea2v2r:SetTexture(r, g, b);
		DopieArenaInfoConfig_chk2v2r:SetChecked(oConfig.enabled);
	end
	
	oConfig = PUG_ARENA_CONFIG["ARENA_CONFIG"]["3v3r"];	
	if(oConfig ~= nil) then
		r,g,b = DopieArenaInfo_HexToRGBPerc(oConfig.color);
		DopieArenaInfoConfig_ColorArea3v3r:SetTexture(r, g, b);
		DopieArenaInfoConfig_chk3v3r:SetChecked(oConfig.enabled);
	end
	
	oConfig = PUG_ARENA_CONFIG["ARENA_CONFIG"]["5v5r"];	
	if(oConfig ~= nil) then
		r,g,b = DopieArenaInfo_HexToRGBPerc(oConfig.color);
		DopieArenaInfoConfig_ColorArea5v5r:SetTexture(r, g, b);
		DopieArenaInfoConfig_chk5v5r:SetChecked(oConfig.enabled);
	end
	
end


function DopieArenaInfo_DisplayCharacterData(who,a_bUpdateFrame)
	
	if (DopieArenaInfo_bTurnedOn) then
		local oDB = PUG_ARENA["ARENA_CHARACTERS"];
		local oConfigDB = PUG_ARENA_CONFIG["ARENA_CONFIG"];
		local oConfigOption = nil;
		local sDefaultColor = PUG_ARENA_CONFIG["ARENA_CONFIG"]["default"]["color"];

		local oMember = oDB[who];
		if (oMember ~= nil) then
			
			--## General Info
			local sMsg = "";
			local sLineObject="";
			local iLine=1;
			local bIsMelee = IsMeleeClass(oMember.class);
			local bIsCaster = IsCasterClass(oMember.class);
			local objLine=nil;
			local sFontColor="";
			
			--## Clear lines of all text
			
			if(a_bUpdateFrame) then
				for i=1,10 do
					sLineObject = "DopieArenaInfoFrame" .. DopieArenaInfo_CurrentFrameNumber .. "_Line" .. i;
					objLine = getglobal(sLineObject);
					objLine:SetText("");				
				end
			end
			
			--## Name
			
			local arrName = { strsplit("-",who); };
			local lArrayCount = table.getn(arrName);
			if (lArrayCount == 2) then
				sMsg = trim(arrName[2]) .. " (" .. trim(arrName[1]) .. ")";
			end
			if (lArrayCount == 1) then
				sMsg = trim(arrName[1]) .. " (" .. string.lower(GetRealmName()) .. ")";
   	 		end
   	 		
			sLineObject = "DopieArenaInfoFrame" .. DopieArenaInfo_CurrentFrameNumber .. "_CharName";
			objLine = getglobal(sLineObject);
			if(a_bUpdateFrame) then
				objLine:SetText(sDefaultColor .. sMsg);
			end
			sLineObject = "DopieArenaInfoFrame" .. DopieArenaInfo_CurrentFrameNumber .. "_Line" .. iLine;
			
			
			--## Race and Class
			oConfigOption = oConfigDB["classrace"];
			if oConfigOption ~= nil then
				if oConfigOption.enabled == 1 then
					sMsg = oConfigOption.color .. oMember.race .. " " .. oMember.class .. sDefaultColor;
					GameTooltip:AddLine(sFontColor .. sMsg);
					objLine = getglobal(sLineObject);
					if(a_bUpdateFrame) then
						objLine:SetText(sMsg);
					end
					iLine = iLine + 1;
					sLineObject = "DopieArenaInfoFrame" .. DopieArenaInfo_CurrentFrameNumber .. "_Line" .. iLine;
				end
			end
			
			--## HP and Mana
			sMsg = "";
			oConfigOption = oConfigDB["hp"];			
			if oConfigOption ~= nil then
				if oConfigOption.enabled == 1 then
					sMsg = sDefaultColor .. "HP:[" .. oConfigOption.color .. oMember.hp .. sDefaultColor .. "] ";
				end
			end
			
			oConfigOption = oConfigDB["mp"];			
			if oConfigOption ~= nil then
				if oConfigOption.enabled == 1 then
					sMsg = sMsg .. sDefaultColor .. "MP:[" .. oConfigOption.color .. oMember.mp .. sDefaultColor .. "]";		
				end
			end
			
			if(sMsg ~= "") then
				GameTooltip:AddLine(sMsg);
				objLine = getglobal(sLineObject);
				if(a_bUpdateFrame) then
					objLine:SetText(sMsg);
				end
				iLine = iLine + 1;
				sLineObject = "DopieArenaInfoFrame" .. DopieArenaInfo_CurrentFrameNumber .. "_Line" .. iLine;	
			end
			
			
			--## Talents
			oConfigOption = oConfigDB["talents"];			
			if oConfigOption ~= nil then
				if oConfigOption.enabled == 1 then
					sMsg = sDefaultColor .. "Talents: [" .. oConfigOption.color ..  oMember.talents .. sDefaultColor ..  "]";
					GameTooltip:AddLine(sMsg);
					objLine = getglobal(sLineObject);
					if(a_bUpdateFrame) then
						objLine:SetText(sMsg);
					end
					iLine = iLine + 1;
					sLineObject = "DopieArenaInfoFrame" .. DopieArenaInfo_CurrentFrameNumber .. "_Line" .. iLine;
				end
			end
			
			
			--## If caster, display caster related stats
			if(bIsCaster) then
				oConfigOption = oConfigDB["bheal"];			
				if oConfigOption ~= nil then
					if oConfigOption.enabled == 1 then
						sMsg = sDefaultColor .. "Heal: [" .. oConfigOption.color .. "+" .. oMember.bheal .. sDefaultColor .. "]";
						GameTooltip:AddLine(sMsg);
						objLine = getglobal(sLineObject);
						if(a_bUpdateFrame) then
							objLine:SetText(sMsg);
						end
						iLine = iLine + 1;
						sLineObject = "DopieArenaInfoFrame" .. DopieArenaInfo_CurrentFrameNumber .. "_Line" .. iLine;
					end
				end
				
				oConfigOption = oConfigDB["sdmg"];			
				if oConfigOption ~= nil then
					if oConfigOption.enabled == 1 then
						sMsg = sDefaultColor .. "Spell: [" .. oConfigOption.color .. oMember.sdmg .. sDefaultColor .. "]";		
						GameTooltip:AddLine(sMsg);
						objLine = getglobal(sLineObject);
						if(a_bUpdateFrame) then
							objLine:SetText(sMsg);
						end
						iLine = iLine + 1;
						sLineObject = "DopieArenaInfoFrame" .. DopieArenaInfo_CurrentFrameNumber .. "_Line" .. iLine;
					end
				end							
			end
			--## Else display melee related stats
			if(bIsMelee) then
			
				if(oMember.mhdps > 0) then
					sMsg = sDefaultColor .. "Main hand ";
					
					oConfigOption = oConfigDB["mhdmg"];			
					if oConfigOption ~= nil then
						if oConfigOption.enabled == 1 then
							sMsg = sMsg .. oConfigOption.color .. oMember.mhdmgmin .. " - " .. oMember.mhdmgmax .. sDefaultColor .. " ";	
						end
					end
					
					oConfigOption = oConfigDB["mhdps"];			
					if oConfigOption ~= nil then
						if oConfigOption.enabled == 1 then
							sMsg = sMsg .. sDefaultColor .. "Dps: " .. oConfigOption.color ..  oMember.mhdps .. sDefaultColor .. " ";
						end
					end
					
					oConfigOption = oConfigDB["mhspeed"];			
					if oConfigOption ~= nil then
						if oConfigOption.enabled == 1 then
							sMsg = sMsg .. sDefaultColor .. "Speed: " .. oConfigOption.color ..  oMember.mhspeed .. sDefaultColor .. " ";
						end
					end
					
					if(sMsg ~= sDefaultColor .. "Main hand ") then
						GameTooltip:AddLine(sMsg);
						objLine = getglobal(sLineObject);
						if(a_bUpdateFrame) then
							objLine:SetText(sMsg);
						end
						iLine = iLine + 1;
						sLineObject = "DopieArenaInfoFrame" .. DopieArenaInfo_CurrentFrameNumber .. "_Line" .. iLine;
					end
					
				end
				
				--## Display offhand info if they got one
				if(oMember.ohdps > 0) then
					sMsg = sDefaultColor .. "Off hand ";
										
					oConfigOption = oConfigDB["ohdmg"];			
					if oConfigOption ~= nil then
						if oConfigOption.enabled == 1 then
							sMsg = sMsg .. oConfigOption.color .. oMember.ohdmgmin .. " - " .. oMember.ohdmgmax .. sDefaultColor .. " ";	
						end
					end

					oConfigOption = oConfigDB["ohdps"];			
					if oConfigOption ~= nil then
						if oConfigOption.enabled == 1 then
							sMsg = sMsg .. sDefaultColor .. "Dps: " .. oConfigOption.color ..  oMember.ohdps .. sDefaultColor .. " ";
						end
					end

					oConfigOption = oConfigDB["ohspeed"];			
					if oConfigOption ~= nil then
						if oConfigOption.enabled == 1 then
							sMsg = sMsg .. sDefaultColor .. "Speed: " .. oConfigOption.color ..  oMember.ohspeed .. sDefaultColor .. " ";
						end
					end

					if(sMsg ~= sDefaultColor .. "Off hand ") then
						GameTooltip:AddLine(sMsg);
						objLine = getglobal(sLineObject);
						if(a_bUpdateFrame) then
							objLine:SetText(sMsg);
						end
						iLine = iLine + 1;
						sLineObject = "DopieArenaInfoFrame" .. DopieArenaInfo_CurrentFrameNumber .. "_Line" .. iLine;
					end
				end
				
								
				--## Display ranged information if the class is hunter
				if(string.lower(oMember.class) == "hunter") then
					
					
					sMsg = sDefaultColor .. "Ranged ";
															
					oConfigOption = oConfigDB["rndmg"];			
					if oConfigOption ~= nil then
						if oConfigOption.enabled == 1 then
							sMsg = sMsg .. oConfigOption.color .. oMember.rndmgmin .. " - " .. oMember.rndmgmax .. sDefaultColor .. " ";	
						end
					end

					oConfigOption = oConfigDB["rndps"];			
					if oConfigOption ~= nil then
						if oConfigOption.enabled == 1 then
							sMsg = sMsg .. sDefaultColor .. "Dps: " .. oConfigOption.color ..  oMember.rndps .. sDefaultColor .. " ";
						end
					end

					oConfigOption = oConfigDB["rnspeed"];			
					if oConfigOption ~= nil then
						if oConfigOption.enabled == 1 then
							sMsg = sMsg .. sDefaultColor .. "Speed: " .. oConfigOption.color ..  oMember.rnspeed .. sDefaultColor .. " ";
						end
					end

					if(sMsg ~= sDefaultColor .. "Ranged ") then
						GameTooltip:AddLine(sMsg);
						objLine = getglobal(sLineObject);
						if(a_bUpdateFrame) then
							objLine:SetText(sMsg);
						end
						iLine = iLine + 1;
						sLineObject = "DopieArenaInfoFrame" .. DopieArenaInfo_CurrentFrameNumber .. "_Line" .. iLine;
					end
					
					
					
					
					sMsg = ""
					oConfigOption = oConfigDB["rnatkpwr"];			
					if oConfigOption ~= nil then
						if oConfigOption.enabled == 1 then
							sMsg = sMsg .. sDefaultColor .. "Atk: " .. oConfigOption.color .. oMember.rnatkpwr .. sDefaultColor .. " ";	
						end
					end
					
					oConfigOption = oConfigDB["rnhitr"];			
					if oConfigOption ~= nil then
						if oConfigOption.enabled == 1 then
							sMsg = sMsg .. sDefaultColor .. "+Hit: " .. oConfigOption.color .. oMember.rnhitr .. sDefaultColor .. " ";	
						end
					end
					
					
					oConfigOption = oConfigDB["rncrit"];			
					if oConfigOption ~= nil then
						if oConfigOption.enabled == 1 then
							sMsg = sMsg .. sDefaultColor .. "%Crit: " .. oConfigOption.color .. oMember.rncrit .. sDefaultColor .. " ";	
						end
					end
					
					if(sMsg ~= "") then
						GameTooltip:AddLine(sMsg);
						objLine = getglobal(sLineObject);
						if(a_bUpdateFrame) then
							objLine:SetText(sMsg);
						end
						iLine = iLine + 1;
						sLineObject = "DopieArenaInfoFrame" .. DopieArenaInfo_CurrentFrameNumber .. "_Line" .. iLine;
					end
					
					
				else
				
					--## Display Melee Atk Power, Hit Rating and Crit Chance
					sMsg = ""
					oConfigOption = oConfigDB["mhatkpwr"];			
					if oConfigOption ~= nil then
						if oConfigOption.enabled == 1 then
							sMsg = sMsg .. sDefaultColor .. "Atk: " .. oConfigOption.color .. oMember.mhatkpwr .. sDefaultColor .. " ";	
						end
					end

					oConfigOption = oConfigDB["mhhitr"];			
					if oConfigOption ~= nil then
						if oConfigOption.enabled == 1 then
							sMsg = sMsg .. sDefaultColor .. "+Hit: " .. oConfigOption.color .. oMember.mhhitr .. sDefaultColor .. " ";	
						end
					end


					oConfigOption = oConfigDB["mhcrit"];			
					if oConfigOption ~= nil then
						if oConfigOption.enabled == 1 then
							sMsg = sMsg .. sDefaultColor .. "%Crit: " .. oConfigOption.color .. oMember.mhcrit .. sDefaultColor .. " ";	
						end
					end

					if(sMsg ~= "") then
						GameTooltip:AddLine(sMsg);
						objLine = getglobal(sLineObject);
						if(a_bUpdateFrame) then
							objLine:SetText(sMsg);
						end
						iLine = iLine + 1;
						sLineObject = "DopieArenaInfoFrame" .. DopieArenaInfo_CurrentFrameNumber .. "_Line" .. iLine;
					end
				end
				
			end
			
			
			oConfigOption = oConfigDB["resil"];			
			if oConfigOption ~= nil then
				if oConfigOption.enabled == 1 then
					sMsg = sDefaultColor .. "Resilience: [" .. oConfigOption.color .. oMember.resil .. sDefaultColor .. "]";		
					GameTooltip:AddLine(sMsg);
					objLine = getglobal(sLineObject);
					if(a_bUpdateFrame) then
						objLine:SetText(sMsg);
					end
					iLine = iLine + 1;
					sLineObject = "DopieArenaInfoFrame" .. DopieArenaInfo_CurrentFrameNumber .. "_Line" .. iLine;
				end
			end	
			
			
			sMsg="";
			if (oMember["2v2r"] ~= nil) then
				oConfigOption = oConfigDB["2v2r"];			
				if oConfigOption ~= nil then
					if oConfigOption.enabled == 1 then
						sMsg = sDefaultColor .. "2v2: [" .. oConfigOption.color .. oMember["2v2r"] .. sDefaultColor .. "]";
					end
				end
			end
			if (oMember["3v3r"] ~= nil) then
				oConfigOption = oConfigDB["3v3r"];			
				if oConfigOption ~= nil then
					if oConfigOption.enabled == 1 then
						sMsg = sMsg .. sDefaultColor ..  " 3v3: [" .. oConfigOption.color .. oMember["3v3r"] .. sDefaultColor .. "]";
					end
				end
			end
			if (oMember["5v5r"] ~= nil) then
				oConfigOption = oConfigDB["5v5r"];			
				if oConfigOption ~= nil then
					if oConfigOption.enabled == 1 then				
						sMsg = sMsg .. sDefaultColor .. " 5v5: [" .. oConfigOption.color .. oMember["5v5r"] .. sDefaultColor .. "]";
					end
				end
			end
			
			if(sMsg ~= "") then
				GameTooltip:AddLine(sMsg);	
				objLine = getglobal(sLineObject);
				if(a_bUpdateFrame) then
					objLine:SetText(sMsg);
				end
				iLine = iLine + 1;
				sLineObject = "DopieArenaInfoFrame" .. DopieArenaInfo_CurrentFrameNumber .. "_Line" .. iLine;
			end
			
			GameTooltip:Show();		
		end
	end
end



function DopieArenaInfo_PrintCharacterData(who)
	

end



function DopieArenaInfo_Enable()
	DopieArenaInfo_bTurnedOn = true;
	Print_Msg("Dopie's ARENA Info: Enabled");
end

function DopieArenaInfo_Disable()
	DopieArenaInfo_bTurnedOn = false;
	Print_Msg("Dopie's ARENA Info: Disabled");
end

function DopieArenaInfo_DisplayHelp()

	Print_Msg("Dopie's ARENA Info: ------- .:Command List:. -------");
	

end



----------------------------------------------------------------------------------
-- Print_Msg(sMsg)
-- Prints a msg to the chat window
-- 
---------------------------------------------------------------------------------
function Print_Msg(msg)
   ChatFrame1:AddMessage("DopieArenaInfo: "..msg, 1.0, 1.0, 0.5);
end


function DopieArenaInfoRound(x)
	if(x - math.floor(x) > 0.5) then
		x = x + 0.5;
	end
	return math.floor(x);
end

function DopieArenaInfo_RGBPercToHex(r, g, b)
	return string.format("%02x%02x%02x", r*255, g*255, b*255)
end

function DopieArenaInfo_RGBToHex(r, g, b)
	return string.format("%02x%02x%02x", r, g, b)
end

function DopieArenaInfo_HexToRGBPerc(hex)
	local rhex, ghex, bhex = string.sub(hex, 5, 6), string.sub(hex, 7, 8), string.sub(hex, 9, 10)
	return tonumber(rhex, 16)/255, tonumber(ghex, 16)/255, tonumber(bhex, 16)/255
end

function IsMeleeClass(class)

	local bIsMelee;
	
	if(string.lower(class) == "warrior") then
		bIsMelee = true;
	elseif(string.lower(class) == "rogue") then
		bIsMelee = true;
	elseif(string.lower(class) == "hunter") then
		bIsMelee = true;
	elseif(string.lower(class) == "druid") then
		bIsMelee = true;
	elseif(string.lower(class) == "paladin") then
		bIsMelee = true;
	elseif(string.lower(class) == "shaman") then
		bIsMelee = true;
	else
		bIsMelee = false;
	end
	return bIsMelee;
end

function IsCasterClass(class)

	local bIsCaster;
	
	if(string.lower(class) == "paladin") then
		bIsCaster = true;
	elseif(string.lower(class) == "mage") then
		bIsCaster = true;
	elseif(string.lower(class) == "warlock") then
		bIsCaster = true;
	elseif(string.lower(class) == "druid") then
		bIsCaster = true;
	elseif(string.lower(class) == "shaman") then
		bIsCaster = true;
	elseif(string.lower(class) == "priest") then
		bIsCaster = true;
	else
		bIsCaster = false;
	end
	return bIsCaster;
end
